
function Ry = RotY (theta)
	   Ry=[cos(theta)    0  sin(theta)   ;
	        0            1      0        ;
               -sin(theta)    0   cos(theta) 
                     ];
endfunction


function Rz = RotZ (theta)
	   Rz=[cos(theta) -sin(theta) 0 ;
	      sin(theta) cos(theta)   0 ;
	            0         0       1 ;
                    ];
endfunction



function p=generateImage(K,theta1,theta2,theta3,t,P)
	R=RotZ(theta3)*RotY(theta2)*RotZ(theta1);
	RT=[R,t];
	p=K*RT*P;
	for i=[1:size(P)(2)]
	p(:,i)=p(:,i)./p(3,i);
	endfor
end



#Obtaining model points 
args=argv();


fx =str2num(args{1,1});
fy =str2num(args{2,1});
s  =str2num(args{3,1});
u0 =str2num(args{4,1});
v0 =str2num(args{5,1});

K=[
fx s u0;
0 fy v0;
0 0 1
];

theta1=str2num(args{6,1})*pi/180;
theta2=str2num(args{7,1})*pi/180;
theta3=str2num(args{8,1})*pi/180;
t=[str2num(args{9,1});str2num(args{10,1});str2num(args{11,1})];

pointCloudArguments=args(12:length(args));
pointsNumber=length(pointCloudArguments)/2;

pointCloud=[str2num(pointCloudArguments{1,1});str2num(pointCloudArguments{2,1});0;1];

for i =[3:2:pointsNumber*2]
  pointCloud=[pointCloud,[str2num(pointCloudArguments{i,1});str2num(pointCloudArguments{i+1,1});0;1]];
endfor

cenroidX=mean(pointCloud(1,:));
cenroidY=mean(pointCloud(2,:));
pointCloud(1,:)=pointCloud(1,:)-cenroidX;
pointCloud(2,:)=pointCloud(2,:)-cenroidY;

imagePoints=generateImage(K,theta1,theta2,theta3,t,pointCloud);
imagePoints=imagePoints(1:2,:);
#Converting image points to pixels and printing result
for i=[1:pointsNumber]
  printf("%d %d ",floor(imagePoints(1,i)+0.5),floor(imagePoints(2,i)+0.5));
endfor
#plot(imagePoints(1,:),imagePoints(2,:));
#axis ("square");
#xlim ([0 640])
#ylim ([0 480])
#pause
